

/* w = wavelength (nm) */
/* B = W/(m^2*sr*um) */
/* T = deg K */
/* Sun is considered to be black-body of 5900 K. */

c = 2.998e8;
h = 6.626e-34;
k = 1.380e-23;
T = 3200;

xsun = 0;
tungsten1 = 1;
tungsten2 = 2;

xcolor = tungsten1;

/* for sun: */

if (xcolor==xsun) {
  T = 5900;
  norm =  2.9210687e+13;
}
else
if (xcolor==tungsten1) {
  T = 3400;
  norm = 1.838e+12;
};


minwav = 380;
maxwav = 800;
wavinc = 5;

linelen = 8;

for (w=minwav,p=1; w <= maxwav; w+= wavinc, p++) {

     l = w * 1e-9;
     B = 2 * h * c^2 / ( l^5 * (exp (h * c / ( k * l * T)) - 1));

//  print w,B/norm;
  printf ("%6.4g, ",B/norm);
  if (p>=linelen) {
        printf ("\n");
        p = 0;
  };
};

