/* control.h */

int nrecrd;
int nstim;
int silent;
int vidmode;
int disp;
int prmap;
int stim_elem;

/* default values for some constants */

double vk;
double vna;
double vcl;
double dnai;             	/* internal [Na] = 12 mM, used for Na vrev */
double dnao;             	/* external [Na] = 130 mM, used for Na vrev */
double dpkna;              	/* K perm / Na perm = .09, used for Na vrev */
double dpcana;              	/* Ca perm / Na perm = .09, used for Na vrev */
double dko;              	/* external [K] = 6.5 mM, used for K vrev */
double dki;              	/* internal [K] = 130 mM, used for K,Ca vrev */
double dpnak;              	/* Na perm / K perm = .02, used for K vrev */
double dpcak;              	/* Ca perm / K perm = .01, used for K vrev */
double dpnaca;              	/* Na perm / Ca perm = 1e-3, for Ca vrev */
double dpkca;              	/* K perm / Ca perm =.33e-3, for Ca vrev */
double dclo;             	/* external [Cl] = 125 mM, used for Cl vrev */
double dcli;             	/* internal [Cl] = 10 mM, used for Cl vrev */
double dcap;             	/* membrane capacitance */
double ddia;
double dlen;
double dri;			/* axial resistance */
double drg;			/* gap junction resistance */
double drm;			/* membrane resistance */
double dsfa;			/* synaptic filters 1 */
double dfta;			/* synaptic time constant */
double dftah;			/* high pass synaptic time constant */
double dsfb;			/* synaptic filters 2 */
double dftb;			/* synaptic time constant */
double dscu;			/* unitary conductance of chans */
double dsvn;			/* number of vesicle release sites */
double dvsz;			/* size of vesicles released */
double dst;			/* synaptic threshold */
double dsc;			/* synaptic curve */
double dmaxsyn;			/* maximum cond for synapse */
double dskd;			/* half-max saturation gain */
double dshc;			/* synaptic postsyn Hill coeff */
double dstr;			/* transmitter conc for markov st receptors */
double dgkd;			/* half-max cG saturation */
double dsn;			/* synaptic neurotransmitter gain */
double dsg;			/* synaptic cycG gain */
double dsei;			/* synaptic input gain for expon */
double dmaxrod;			/* maximum cond for rod          */
double dmaxcon;			/* maximum cond for cone         */
double dnadens;			/* density for Na chan (S/cm2)   */
double dkdens;			/* density for K chan (S/cm2)    */
double dcadens;			/* density for Ca chan (S/cm2)   */
double dmaxna;			/* maximum cond for Na channel   */ 
double dnau;			/* unitary cond for Na channel   */       
double dku;			/* unitry cond for K channel     */
double dkau;			/* unitry cond for KA channel    */
double dkcabu;			/* unitry cond for Kca BK channel*/
double dkcasu;			/* unitry cond for Kca SK channel*/
double dkihu;			/* unitry cond for Ih channel    */
double dcalu;			/* unitry cond for Ca T channel  */
double dcatu;			/* unitry cond for Ca L channel  */
double dampau;			/* unitry cond for AMPA channel  */
double dcgmpu;			/* unitry cond for cGMP channel  */
double dmaxampa;		/* maximum cond for AMPA channel */ 
double dmaxnmda;		/* maximum cond for NMDA channel */ 
double dmaxgaba;		/* maximum cond for GABA channel */ 
double dnaoffsm;		/* offset activation voltage for Na channel */ 
double dnaoffsh;		/* offset inactivation voltage for Na channel */ 
double dmaxk;			/* maximum cond for K channel */ 
double dkoffsn;			/* offset activation   voltage for K channel */ 
double dkoffsh;			/* offset inactivation voltage for K channel */ 
float dnataud;			/* tau for Na noise in 2-state model */
float dktaud;			/* tau for K noise in 2-state model */
float dnataum;			/* act. tau for Na channel (must be float) */ 
float dnatauh;			/* inact. tau for Na channel (must be float) */ 
float dktaum;			/* act. tau for K channel    */ 
float dktauh;			/* inact. tau for K channel  */ 
float dcataum;			/* act. tau for Ca channel (must be float) */ 
float dcatauh;			/* inact. tau for Ca channel (must be float) */ 
float dkcataum;			/* act. tau for Kca channel    */ 
float dkcatauh;			/* inact. tau for Kca channel  */ 
float dsyntau;			/* tau for syn2 channel  */ 
float dnmdamg;			/* mg conc for NMDA channel */ 
float dqm;               	/* Q10 for am, bm */
float dqh;               	/* Q10 for ah, bh, normally 3 */
float dqn;               	/* Q10 for an, bn, normally 3 */
float dqca;               	/* Q10 for ac, bc (Ca chan) */
float dqd;               	/* Q10 for ad, bd (KA h) */
float dqsyn;             	/* Q10 for synaptic chans */
float dqcab;             	/* Q10 for Ca buffer */
float dqkca;             	/* Q10 for Kca chan */
float dqc;             		/* Q10 for channel conductance */
float dqcavmax;             	/* Q10 for Ca pump */
float dqrec;             	/* Q10 for photoreceptor transduction shape */
float dqcrec;             	/* Q10 for photoreceptor transduction cond */
float dgjoff;			/* gap junction voltage offset */
float dgjtau;			/* activation time const for gap junction */
float dgjnv;			/* non-volt-sens fraction of gj conductance */
double dcavoff;          	/* Q10 for voffset from cao */ 
double dcaspvrev;          	/* Ca surface potential for vrev(mult dcavoff)*/
double ddca;			/* Diffusion const for internal calcium cm2/s */
double dcoo;			/* external cobalt concentration (for cavoff) */
double dmgo;			/* external magnesium conc (for cavoff) */
double dcao;			/* external calcium concentration */
double dcai;			/* internal calcium concentration */
double dcapkm;			/* 1/2 sat. conc. for Ca pump */
double dcavmax;			/* Vmax for Ca pump */
double dcakex;			/* Rate for Na/Ca exchanger */
double dcabnd;			/* Ratio of bound to free calcium */
double dcabt;			/* Ca buffer total in shells */
double dcabti;			/* Ca buffer total in first shell */
double dcabf;			/* forward rate to Ca.B */
double dcabr;			/* reverse rate to Ca.B */
double dmaxca;			/* maximum cond for Ca channel */ 
double dcaoffs;			/* Voltage activation offset for ca chan */
double dbd1;			/* default d1 for KCa BK channel    */ 
double dbd2;			/* default d2 for KCa BK channel    */ 
double dbk1;			/* default k1 for KCa BK channel    */ 
double dbk2;			/* default k2 for KCa BK channel    */ 
double dsd1;			/* default d1 for KCa SK channel    */ 
double dsd2;			/* default d2 for KCa SK channel    */ 
double dsk1;			/* default k1 for KCa SK channel    */ 
double dsk2;			/* default k2 for KCa SK channel    */ 

double complam;
double lamcrit;
double xtime;
double timinc;
double stiminc;
double tempcel;
double dpki;
double frt;
double f2rt;
double r2ft;
double ktemp;
double ktrb;
double djnoise;
double endexp;
double psplen;
double recrd;
double ploti;
double plmax;
double plmin;
double rate;
double stloc;
double crit;
double relax;
double relincr;
double synaptau;
double calcnernst;	/* =1 -> realc Nernst pots., not internal ions */

int    dcashell;		/* Number of Ca diffusion shells */
int    debug;
int    debugz;
int    poisfl;
int    scatter;
int    plsep;
int    allowrev;
int    dashfl;
int    euler;
int    implicit;
int    stimelem;
int rseed;
int prseed;
extern int drseed;
int ncversion[3];
