/* research simulation of A-> B process with discrete time steps */

#include <stdlib.h>
#include <math.h>
//#include <nr.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <math.h>
#include <stdio.h>

#ifdef __cplusplus
}
#endif

double bnldev(double pp, register int n);

int  main(){
        float tau=.55;
        float time, timestep=0.5;
        float subtime, subtimestep;
        float p, p_corr, p_small;                       
        float a1 ,a2, a_uncor;
                                
        subtimestep= tau/100;
        
        p_corr= 1-exp(-timestep/tau);           
        p = timestep/tau;
        p_small = subtimestep/tau;
        
        a1= 1e6;
        a2= 1e6;
        a_uncor= 1e6;
        
        for (time = 0; time <=5; time+= timestep){
                a1 -= bnldev(p_corr, (int)a1);
                a_uncor -= bnldev(p, (int)a_uncor);
                for (subtime=time; subtime <= time+timestep; 
						subtime+= subtimestep){
                        a2 -= bnldev(p_small, (int)a2);                                       
                }
                printf("%g %g %g %g\n", time+timestep/2, a1, a_uncor, a2 );
        }
        exit(0);
char *malloc(unsigned int n);
}




#define MAXRAND 2147483647.0
#define INVMAXRAND 4.6566128752457969231e-10		/* 1 / MAXRAND */
#define RANDSTATSIZ 256

static char _rstate[RANDSTATSIZ] = {0};

double drand(void)
{
  int r_random(void);

  return (r_random() * INVMAXRAND);
}

#include "ncsub.h"

void restorstate(void);

/*------------------------------------*/

double bnldev(double pp, register int n)
              
/* Taken from Press et al. 1988, "Numerical Recipes in C", p 223.
   Returns as a floating point number an integer value 
   that is a random deviate drawn from a binomial distribution
   of n trials each of probability pp, using drand() as a
   source of uniform random deviates.
*/

{
   register int j;
   register int bnl;
   static int nold = -1;  			     /* must be static */
   static double pold = -1, pc, plog,pclog,en,oldg;  /* must be static */
   static double am,em,g,angle,p,sq,t,y,z;
   double drand(), gammln2(double xx);
   void restorstate();

   if (pp > 1.0) pp = 1.0;
   if (pp < 0.0) pp = 0.0;
   p = (pp <= 0.5? pp : 1-pp);
   if (n < 50) {			/* use direct method if n is small */
      bnl = 0;
      for (j=1; j<=n; j++) 
	 if (drand() < p) bnl++;
   }
   else if ((am=n*p) < 1.0) {		/* if fewer than 1 event is expected */
      g = exp(-am);			/*  in 25 or more trials, then */
      t = 1.0;				/*  use Poisson method */
      for (j=0; j<n; j++) {
         t *= drand();
	 if (t < g) break;
      }
      bnl = j;
   }
   else {				/* use rejection method */
      if (n != nold) {
	 en = n;
	 oldg = gammln2(en+1.0);
	 nold = n;
      }
      if (p != pold) {			/* if p has changed */
	pc = 1.0 - p;
	plog = log(p);
	pclog = log(pc);
	pold = p;
      }
      sq = sqrt(2.0*am*pc);		/* rejection method with Lorentzian */
      do {				/* comparison function */
	do {
	   angle = drand();
	   if (angle == 0.5) angle = .49999999999;	
	   y = tan(MPI*angle);
	   em = sq*y+am;
	} while (em < 0.0 || em >= (en+1.0));	/* reject */
	em = floor(em);
	z = oldg-gammln2(em+1.0) - gammln2(en-em+1)+em*plog+(en-em)* pclog;
	if (z < -300.0) z = -300.0;	/* to fix range bug in exp() */
	t = 1.2 * sq * (1.0+y*y) * exp(z);

//	t = 1.2 * sq * (1.0+y*y) * exp(oldg-gammln2(em+1.0)
//		- gammln2(en-em+1) + em * plog+ (en-em) * pclog);

      } while (drand() > t);		/* reject. This happens about 1.5 */
      bnl = int(em);			/* times per deviate, on average. */
   }
   if (p != pp) bnl = n -bnl;
//   restorstate();			/* restore default random state  */
   return ((double)bnl);
}

/*------------------------------------*/

double fact(double f) {

  if (f > 1) return (f*fact(f-1));
  else       return 1;

}

/*------------------------------------*/

double gammln2(register double xx)

/* Approximation to the log(gamma) function */
/*  Table lookup is used. Table expands up to 10000 */

#define MAXGAMTABSIZ 20000

{
   register int x;
   static int runyet=0;
   static double y  = 0.5*log(2.0*MPI);
   double f,val;
   static int gamtabsiz = 0;
   static double *gamtab=(double*)NULL;
   double gammln(double xx);

 x = int (xx);
 if (x < MAXGAMTABSIZ) {		/* if too big, use approximation */
   if (x >= gamtabsiz) { 		/* make bigger table */
        register int i,j,mingam;
	double *ngamtab;
	static int ngamtabsiz;

    ngamtabsiz = int(xx/1024+1) * 2048;
    if (ngamtabsiz > MAXGAMTABSIZ) ngamtabsiz = MAXGAMTABSIZ;

  /* fprintf (stderr,"making new gamtab size %d\n",ngamtabsiz); */

    ngamtab = (double *)malloc(ngamtabsiz*sizeof(double));
    if (gamtab) {			
      for (i=0; i<gamtabsiz; i++)	/* copy old table into new */
          ngamtab[i] = gamtab[i]; 
      for (; i<ngamtabsiz; i++)		/* fill rest with zeroes */
          ngamtab[i] = 0.0;
      free(gamtab);
      mingam = gamtabsiz-1;
    } 
    else {
      ngamtab[0] = 0;
      ngamtab[1] = 0;
      mingam = 1;
    }
    gamtab = ngamtab;
    gamtabsiz = ngamtabsiz;
    for (i=mingam+1,f=j=i-1; i<gamtabsiz; f=j=i++) {
       gamtab[i] = gamtab[j] + log(f);
    }
  /* fprintf (stderr,"gamtab done\n"); */
  } 
  if (x < gamtabsiz) {			/* use table lookup */
    val = gamtab[x];
  }
 }
 else {
   val = (xx - 0.5) * log(xx) - xx + y + 0.083333754/xx;
 }				/* error corrected < 2e-10 for xx > 2000 */
 return val;
}

/*------------------------------------*/


