
#define PLOTNODSIZ 100
#define VREC 1                          /* record voltage for graphing node */
#define IREC 2                          /* record current for graphing node */
#define LREC 3                          /* record light for graphing node */
#define GREC 4                          /* number for graphing */
#define SREC 5                          /* symbol variable for graphing */

#define CREC_GLU  6                     /* nt conc, cA/GMP for graphing */
#define CREC_AMPA 7			/* Keep these in order */
#define CREC_NMDA 8			/* here and in nc.y */
#define CREC_CNQX 9
#define CREC_GABA 10
#define CREC_BIC  11
#define CREC_PTX  12
#define CREC_GLY  13
#define CREC_STRY 14
#define CREC_CAMP 15                     
#define CREC_CGMP 16	

#define CREC_CACONC  17			/* Ca concentration outside */
#define CREC_CAV   18
#define CREC_CAIT  19
#define CREC_CAIP  20
#define CREC_CAIE  21
#define CREC_CAIPE 22
#define CREC_CABUF 23 	/* must change NREC in ncsub.h if this goes past 39 */

#define PLINES  'P'                     /* plots have only lines */
#define LINES   'L'                     /* plots have chars and lines */
#define NOLINES 'N'                     /* plots have chars but no lines */

struct lpfilt;

struct plotfr {                 	/* node numbers, vmin, vmax voltages */
        int cnod1;
        int cnod2;
        int cnod3;
        int cnod4;
        double pxmax;
        double pxmin;
        double pymax;
        double pymin;
        double xrange;
        double yrange;
        double oldx;
        double oldy;
        double olddx;
        double olddy;
        char *spnt;             /* pointer to symbol for plotting */
        short int pmod;
        short int pval;
        short int ppen;
        int *vpen;		/* procedure for variable pen */
	lpfilt *filt;		/* digital filter for plotting */
        short automax;		/* maxmin from automatic scaling */
        double csize;		/* size of char for plot */
        char charmode;		/* mode of char plot */
        char charfl;		/* char to be plotted */
        char plframe[20];	/* frame to draw graph in */
        short int newframe;	/* =1 -> first plot in new frame */
        };
        
