/* Module nctest in program nc */

/* Sample procedure to call interpreter from outside program */

/* To use this module, rename "main()" in "ncmain.cc" to
   "ncmain()".  Then use the code in this (nctest) module as
    a template to run "nc" from your C program. 
*/

#include "nc.h"
#include "ncval.h"
#include "y.tab.h"

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#ifdef CPML
#include <cpml.h>
#else
#include <math.h>
#endif

#ifdef __cplusplus
}
#endif

int ncmain(int argc, char **argv);
double *retvar(char *name, int arg1, int arg2, int arg3, int narg);


extern double varval[VVSIZE];    /* temp values for setting variables */
extern char *varpnt[VVSIZE];     /* temp pointers for setting variables */
extern int vartyp[VVSIZE];       /* temp type for setting variables */
extern int varset;               /* index for setting variables */


int main(int argc, char **argv)

{
  static char *comnd = {"nc"};		/* command name */
  static char *file  = {"nctest.n"};	/* first command-line argument */
  static char *ncargv[] = {comnd,file}; /* faked argument list for "nc" */
  static double *val;

  varset = 0;
  varpnt[varset] = "var1";		/* set a variable */
  varval[varset] = 55.67;
  vartyp[varset] = NUMBER;
  varset++;
  if (varset >= VVSIZE) varset = VVSIZE-1;

  ncmain (2,ncargv);			/* run the simulator */
  val = retvar("var1",0,0,0,0);		/* get a pointer to a variable */
  printf ("value of var1 is %g\n",*val);
  val = retvar("var2",0,0,0,1);		/* get a pointer to an array */
  printf ("value of var2 is %g\n",*val);
}

