
FR = 11604.5;
T = 310;
frt = FR/T;
f2rt = 2*FR/T;

naca=dnao/dcao;
kca=dko/dcao;

naratio = dnai/dnao;
kratio = dki/dko;
caratio = dcai/dcao;

naperm = .000;
kperm  = .001;
cperm = 1-naperm-kperm;

for (v = -.1; v < .15; v += .001) {

    dv = 1e-6;
    if (abs(v) < 1e-6) v = 1e-6;
    v4 = v + dv;

    vf = exp(v*frt);
    vf2 = vf*vf;
    vfi = 1 / (1 - vf);
    vfi2 = 1 / (1 - vf2);

    cavfi = (1.0-caratio*vf2)*vfi2;

    navfi = (1.0-naratio*vf)*vfi*naca;
    kvfi  = (1.0-kratio*vf) *vfi*kca;

    cvfi = (cperm*cavfi +
                 naperm*navfi*0.25 +
                 kperm*kvfi*0.25);

    chdf = v * cvfi;

    vf4 = exp(v4*frt);
    vf24 = vf4*vf4;
    vfi4 = 1 / (1 - vf4);
    vfi24 = 1 / (1 - vf24);

    cavfi4 = (1.0-caratio*vf24)*vfi24;

    navfi4 = (1.0-naratio*vf4)*vfi4*naca;
    kvfi4  = (1.0-kratio*vf4) *vfi4*kca;

    cvfi4 = (cperm*cavfi4 +
                 naperm*navfi4*0.25 +
                 kperm*kvfi4*0.25);

    chdf4 = v4 * cvfi4;


    chgfrac4 = (chdf4-chdf) / dv;

    chgfrac = cvfi + frt*v*(2 *   cperm*(1.0-caratio)*vf2*vfi2*vfi2 + 
                        naca*0.25*naperm*(1.0-naratio)*vf*vfi*vfi +
                          kca*0.25*kperm*(1.0- kratio)*vf*vfi*vfi);

    chgvrev = -chdf/chgfrac + v; 
 

//    print v, chdf, chgfrac, chgfrac4+.01; 

    print v, chdf, chgvrev;

};
  

