
/* Experiment to test Ca reversal potential and GHK voltage equation. */
/*  From Lewis, CF, 1979, J. Physiol 286: 417-443. */

/*  Concentrations are expressed as "activities".   */

calcnernst=1;
dcasurfp = .18;

dnao=68.1e-3;	/* 75% of (Normal Ringers = 115e-3, activity 88.2e-3) */
dko=1.97e-3;

dnai=6.5e-3;
dki=80e-3;		/* measured Ki activity */

dcao=10e-3;
dcai=100e-9;
dcavoff= .018;

at 1 sphere dia 1;
at 2 sphere dia 1;

at 1 chan cgmp ndensity 1 ename cgmpx;

//conn 1 to 2 synapse resp nmda ename cgmpx;

step .0001;
print dnao;
print dnai;

print G(vrev) cgmpx;


