
/* na0type.n: Test of Na type 0 channel kinetics */

/*  expt = 1  ->    check Na chan
    expt = 2  ->    check K  chan
*/

timinc = 5e-5;
crit   = 1e-8;
endexp = 1.0;
ploti  = 1e-4;

tempcel= 22;

vna =  .04;
vk  = -.08;
vcl = -.07;

dpnak = 0;
dpkna = 0;
calcnernst = 0;
dcavoff = 0;

ch = "na";		/* Na chan */
ch = "k";		/* K chan */

chtyp = 1;		/* SS type Na channel */
chtyp = 0;		/* HH type Na channel */

ch = "na";

x = setvar();

/*----------------------------------------*/

/*  Graph cinf and its slope, ctau, and calpha and cbeta rate functions */
/*  to show activation behavior */


xvmax =  0.03;
xvmin = -0.10;
xstep = 0.001;

 graph X max xvmax min xvmin;
 graph Y max 1 min 0;
 graph Y max 1 min 0;
 graph Y max 1 min 0;
 graph Y max 20e-3 min 0;
 graph Y max 300 min 0;
 graph Y max 300 min 0;
 graph init;

 gmove (.42,.85);
 gcwidth(.028);
 if      (ch=="na") sprintf (tbuf,"Na type %g\n",chtyp) 
 else if (ch=="k") sprintf (tbuf,"K  type %g\n",chtyp); 
 gtext (tbuf);

 gmove (.22,.8);
 gcwidth(.025);
 if      (ch=="na") sprintf (tbuf,"h inf\n") 
 else if (ch=="k") {
  if (chtyp==3)    sprintf (tbuf,"d inf\n");
 };
 gtext (tbuf);

 gmove (.70,.8);
 gcwidth(.025);
 if      (ch=="na") sprintf (tbuf,"m inf\n") 
 else if (ch=="k")  sprintf (tbuf,"n inf\n");
 gtext (tbuf);

 for (v=xvmin; v <= xvmax; v += xstep) {

  if (ch=="na") {  
    m = minf(v,chtyp);
    h = hinf(v,chtyp);
  }
  else if (ch=="k") {
    m = ninf(v,chtyp);
  if (chtyp==3)   h = dinf(v,chtyp)
  else            h = 0;
  };

  graph (v,m,h);

 };

