/* Display of states in Na channel during spike */
/* with and without noise */

timinc = 1e-6;
ploti=1e-5;
tempcel = 25;
implicit=0;
crit=1e-10;
rseed = 12443;

nchan=50;
nchan=0;

x = setvar();

drm=40000;

at 1 sphere dia  20 vrest -.075;

at 1 chan Na type 1 density 40e-3 chnoise=1 N=nchan ename nass;
at 1 chan K  type 1 density 20e-3 ename kss;  
at 1 chan K  type 2 density 36e-3 ename ka; 
at 1 chan KCa  type 0 density 10e-3 k1 5e-7 ename kca;


at 1 chan Ca type 0 density 4e-3 
	   chnoise=1 N=0 
	   capump vmax 10e-4 
	   caexch cbound 1 
           ename cachan;
/* */

plmax = .04;
plmin = -.08;

plot V[1];
plot G0 nass max 1e-7 min 0; /* */
plot G0 kss max 1e-7 min 0; /* */
plot G0 kca max 1e-7 min 0; /* */
plot G0 ka  max 1e-8 min 0; /* */
plot G0 cachan  max 1e-8 min 0; /* */

stimtime = .0002;
stimdur = .0001;

stim node 1 cclamp 5e-9 start stimtime dur stimdur; /**/

endexp=.0015;
run;
