/*  filter.n  test of plot filters in onplot() */
/*   adapted from "jnoise.n" */

/* uses "chnoise", "jnoise" */

timinc=1e-5;
ploti =1e-5;
endexp=.0007;
tempcel=15;
rseed = 12318;

djnoise=0;		/* if > 0, this turns on Johnson noise */
drm=10000;

x = setvar();

vc= -.00;

r=1119;

at 1 sphere dia .5 vrest=-.07 vrev=vc vrest=-.07 jnoise=1;

at 2 sphere dia .5 vrest=-.07 vrev=vc vrest=-.07;

//conn 1 to 2 cable length 100 dia .5 vrest=-.07 vrev=vc;

at 1 chan Na type 1 ndensity 1 chnoise=1 rsd=r;
at 2 chan Na type 1 ndensity 1 chnoise=1 rsd=r;

stim node 1 vclamp=vc start 0 dur 1;
stim node 2 vclamp=vc start 0 dur 1;

/*----------------------------------------*/

f3len = 100;

dim f3dat[f3len+2];
dim f3wt [f3len+2];

for (i=0; i<f3len; i++) {
    f3dat[i] = 0;
    f3wt[i] = 0;
};

f3wt[0] = 1.0;
f3wt[1] = 0.995;
f3wt[2] = 0.97;
f3wt[3] = 0.82;
f3wt[4] = 0.60;
f3wt[5] = 0.40;
f3wt[6] = 0.20;
f3wt[7] = .10;
f3wt[8] = .02;
f3wt[9] = .00;

f3tot = 0;
for (i=0; i<f3len; i++) {
    f3tot += f3wt[i];
};

func runf3 (val) {
    local i, f3;

/* move filter one timestep */

  for (i=f3len; i>=1; i--) {
    f3dat[i] = f3dat[i-1];
  };
  f3dat[0] = val;

/* calculate weights */

  f3 = 0;
  tot = 0;
  for (i=0; i<f3len; i++) {
    f3 += f3dat[i]*f3wt[i];
  };
  return f3/f3tot;
};

/*----------------------------------------*/
func calctau (tau) {
  local k;

  k = 1.0 - exp (-timinc/tau);

 print k;

 return k;
};

/*----------------------------------------*/

f11 = 0;
f12 = 0;
f13 = 0;
f2 = 0;

kf11 = calctau(1.5e-5);
kf12 = calctau(2e-5);
kf13 = calctau(3e-5);
kf2 =  calctau(7e-5);

graph X max endexp min 0;
graph Y max 0 min -.4e-12;
graph Y max 0 min -.4e-12;
graph Y max 0 min -.4e-12;
graph Y max 0 min -.4e-12;
graph Y max 1 min 0;

graph init;


proc onplot() {

  graph pen (4,2,1,6,11);

  f11 += (I[1] - f11) * kf11;
  f12 += (f11  - f12) * kf12;
  f13 += (f12  - f13) * kf13;
  f2 += (I[1] - f2) * kf2;

  f3 = runf3(I[1]);
  f4 = I[1];
  graph (time, f13, f2, f3, f4, f3wt[time/(2*timinc)]);  
//  graph (time, f13, f2, f3, f4);  
};
/*----------------------------------------*/

//plot I [1] max 0 min -2e-12;
//plot I [2] max 0 min -2e-12;

//plot V [1] max -.069 min -.071;
//plot V [2] max -.069 min -.071;

run;
