/* minf.n */
/* displays minf, hinf, ninf */

xvmax =  0.03;
xvmin = -0.10;
xstep = 0.001;

 graph X max xvmax min xvmin;
 graph Y max 1 min 0;
 graph Y max 1 min 0;
 graph Y max mtaumax min 0;
 graph Y max htaumax min 0;
 graph init;

 gmove (.42,.85);
 gcwidth(.028);
 if      (ch=="na") sprintf (tbuf,"Na type %g\n",chtyp)
 else if (ch=="k") sprintf (tbuf,"K  type %g\n",chtyp);
 gtext (tbuf);

 gmove (.22,.8);
 gcwidth(.025);
 if      (ch=="na") sprintf (tbuf,"h inf\n")
 else if (ch=="k") {
  if (chtyp==3)    sprintf (tbuf,"d inf\n");
 };
 gtext (tbuf);

 gmove (.70,.8);
 gcwidth(.025);
 if      (ch=="na") sprintf (tbuf,"m inf\n")
 else if (ch=="k")  sprintf (tbuf,"n inf\n");
 gtext (tbuf);

 for (v=xvmin; v <= xvmax; v += xstep) {
   local m,h,tm,th;

  if (ch=="na") {
    m = minf(v,chtyp);
    h = hinf(v,chtyp);
    tm = mtau(v,chtyp);
    th = htau(v,chtyp);

  }
  else if (ch=="k") {
    m  = ninf(v,chtyp);
    tm = ntau(v,chtyp);
    if (chtyp==3)   h = dinf(v,chtyp)
    else            h = 0;
    if (chtyp==3)   th = dtau(v,chtyp)
    else            th = 0;
  };

  graph (v,m,h,tm,th);

 };

