/* Test of spike generator */ 
/* single compartement */
/* based on Fohlmeister Miller params. */

/* scompa.n: Script to show spike adaptation. */

timinc = 1e-5;
ploti=1e-4;
tempcel = 22;
implicit=0;
crit=1e-10; 

//dpnak=0;
//dpkna=0;
//dcavoff=0;
//calcnernst=0;

//vna =  0.035; 
//vk  = -0.075; 
//vcl = -.07;

grest = -.063;
dcai = 100e-9; // calcium concentration inside at t0
drm=10000;

na_mult =  1;
ca_mult =  2;
k0_mult =  .3;
k2_mult =  5.; // kca
k3_mult =  7; // ka

x = setvar();

soma = 1;
at soma sphere dia 25 vrest grest vrev -.06;
/* area=2000 um^2 =20*10^-6 cm ^2
/* note: density in -S-/cm2 */

at soma chan 
   Na type 0 density 140e-3*na_mult        
//   Na density 50e-3*na_mult //Fohl
//	chnoise=1 unit=30e-12 
       ename naxx;

at soma chan 
       Ca taum 1 offset .00 
//	density ca_mult*1e-3 
	density ca_mult*3e-3 // Fohl
//	chnoise=1 
	capump vmax 1e-4 km=.5e-6 //caexch kex .5e-9 
	cabuf vmax 1e8 kd .5e-6 btot 3e-6 btoti 10e-6
//	cbound 1
	cshell 10
       ename cachan;

at soma chan 
       KCa type 0 
	density k0_mult* 13e-3 
//	chnoise=1
	ename khh;  
	
at soma chan 
       K type 0 
	density k2_mult*10e-3 
	k1=2e-4 k2=5e-4 d1=0 d2=0 
//	chnoise=1 unit=115e-12
	ename kca;
	
at soma chan /* K_A channel */
       K type 2 
	density k3_mult*35e-3 
//	chnoise=1
	ename ka; 

  /* current clamp, then record spike train and [Ca] */

  waittime = 0.1; // Let the system relax before stimulus.
  stimdur  = 0.4;
  afterstim = 0.00;
  nstim=3;
  endexp=waittime+nstim*stimdur+afterstim;
//endexp = .1;
  stimampl = 30e-12;

for (i=1; i<=nstim; i++) {
    stim node soma cclamp i*stimampl start waittime+(i-1.0)*stimdur dur stimdur; 
};

 plot V[soma] pen 4 max .01 min -.08;
//  plot I[soma] pen 5 max 1e-9 min -1e-9;
//  plot G(I) naxx ; /*I_na*/
//  plot G(I) khh; /* I_k_dr */
//  plot G kca max 10e-9 min 0; /* I Kca */
//  plot Ca(I) [soma]; /* ica*/
  plot Ca(1) [soma] max 3e-6 min 0; /*[ca]*/
//  plot cabuf(1) [soma] max 30e-6 min 0 pen 6; /*[ca]*/
//  plot G(I) ka max 1e-9 min -1e-9; /* IKA*/
// plot V[hillock] pen 3;
// plot V[axon1] pen 3;
// plot G khh pen 5 max 100e-9 min 0;
// plot G ka pen 2 max 1e-9 min 0;
// plot Ca(vrev) [soma] max .1 min 0; 
// plot Ca(5)  [soma] pen 5 max 3e-6 min 0;
  plot Ca(99) [soma] pen 5 max 3e-6 min 0;
// plot  G kca pen 6 max 200e-12 min 0;
  run;

